package webdavupload

import (
    "net/url"
    "strconv"
    "github.com/studio-b12/gowebdav"
    "gitea.armuli.eu/museum-digital/museum-digital-webdav-uploader/src/configloader"
)

// Generates the path for a webdav endpoint for the configured instance and institution.
func getWebDavHost(config configloader.MDWebDavUploaderConfig) string {

    parsed, err := url.Parse(config.InstanceLink)
    if err != nil {
        panic("Your settings must be broken. Failed to load instance URL.")
    }

    output := url.URL{
        Scheme: "https",
        Host: parsed.Host,
        Path: "/musdb/webdav/" + strconv.Itoa(config.InstitutionId),
    }

    return output.String()

}

// Returns a WebDAV client for the current config.
func GetWebdavClient(config configloader.MDWebDavUploaderConfig) *gowebdav.Client {

    c := gowebdav.NewClient(getWebDavHost(config), config.Username, config.WebDavAuthToken)
    c.Connect()
    return c

}
