package webui

import (
    "encoding/json"
	"fmt"
	"net/http"
    "gitea.armuli.eu/museum-digital/museum-digital-webdav-uploader/src/uploadsrcdir"
)

type listUploadableApiResponse struct {
    Metadata []string `json:"metadata"`
    MediaFiles []string `json:"media_files"`
}

// Provides the JSON API for listing all metadata and media files that
// are currently listed to be uploaded.
func serveApiListUploadable(w http.ResponseWriter, r *http.Request) {

	setHeadersForJson(w)

    var output listUploadableApiResponse
    if setupRequired == true {
        output = listUploadableApiResponse{Metadata: []string{}, MediaFiles: []string{}}
    } else {
        uploadableMetadata, uploadableMedia := uploadsrcdir.GetUploadableFiles(config)
        output = listUploadableApiResponse{Metadata: uploadableMetadata, MediaFiles: uploadableMedia}
    }

    outputJson, encodeErr := json.Marshal(output)
    if encodeErr != nil {
        panic("Failed to create JSON")
    }

	fmt.Fprint(w, string(outputJson))

}
